// Generated by delombok at Wed Mar 13 23:07:32 UTC 2024
package gov.cms.fiss.pricers.irf.core.tables;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
import gov.cms.fiss.pricers.irf.core.tables.CmgTableEntry.Fields;
import java.math.BigDecimal;
import javax.annotation.concurrent.Immutable;
import javax.validation.constraints.Digits;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.Pattern;

@Immutable
@JsonDeserialize(builder = CmgTableEntry.CmgTableEntryBuilder.class)
@JsonPropertyOrder({Fields.CMG_CODE, Fields.B_RELATIVE_WEIGHT, Fields.C_RELATIVE_WEIGHT, Fields.D_RELATIVE_WEIGHT, Fields.A_RELATIVE_WEIGHT, Fields.B_AVG_LENGTH_OF_STAY, Fields.C_AVG_LENGTH_OF_STAY, Fields.D_AVG_LENGTH_OF_STAY, Fields.A_AVG_LENGTH_OF_STAY})
public class CmgTableEntry {

  @JsonPOJOBuilder(withPrefix = "")
  public static class CmgTableEntryBuilder {
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private String cmgCode;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private 
    // This annotation is required throughout to ensure the Jackson-generated column names match
    // those from Lombok
    int aAvgLengthOfStay;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private BigDecimal aRelativeWeight;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private int bAvgLengthOfStay;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private BigDecimal bRelativeWeight;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private int cAvgLengthOfStay;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private BigDecimal cRelativeWeight;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private int dAvgLengthOfStay;
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    private BigDecimal dRelativeWeight;

    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    CmgTableEntryBuilder() {
    }

    /**
     * Corresponds to {@code CMG-NUM PIC X(4)} from the COBOL source.
     * @return {@code this}.
     */
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder cmgCode(final String cmgCode) {
      this.cmgCode = cmgCode;
      return this;
    }

    /**
     * Corresponds to {@code A-LOS-TABLE PIC 9(2)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.A_AVG_LENGTH_OF_STAY)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder aAvgLengthOfStay(final int aAvgLengthOfStay) {
      this.aAvgLengthOfStay = aAvgLengthOfStay;
      return this;
    }

    /**
     * Corresponds to {@code A-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.A_RELATIVE_WEIGHT)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder aRelativeWeight(final BigDecimal aRelativeWeight) {
      this.aRelativeWeight = aRelativeWeight;
      return this;
    }

    /**
     * Corresponds to {@code B-LOS-TABLE PIC 9(2)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.B_AVG_LENGTH_OF_STAY)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder bAvgLengthOfStay(final int bAvgLengthOfStay) {
      this.bAvgLengthOfStay = bAvgLengthOfStay;
      return this;
    }

    /**
     * Corresponds to {@code B-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.B_RELATIVE_WEIGHT)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder bRelativeWeight(final BigDecimal bRelativeWeight) {
      this.bRelativeWeight = bRelativeWeight;
      return this;
    }

    /**
     * Corresponds to {@code C-LOS-TABLE PIC 9(2)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.C_AVG_LENGTH_OF_STAY)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder cAvgLengthOfStay(final int cAvgLengthOfStay) {
      this.cAvgLengthOfStay = cAvgLengthOfStay;
      return this;
    }

    /**
     * Corresponds to {@code C-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.C_RELATIVE_WEIGHT)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder cRelativeWeight(final BigDecimal cRelativeWeight) {
      this.cRelativeWeight = cRelativeWeight;
      return this;
    }

    /**
     * Corresponds to {@code D-LOS-TABLE PIC 9(2)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.D_AVG_LENGTH_OF_STAY)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder dAvgLengthOfStay(final int dAvgLengthOfStay) {
      this.dAvgLengthOfStay = dAvgLengthOfStay;
      return this;
    }

    /**
     * Corresponds to {@code D-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
     * @return {@code this}.
     */
    @JsonProperty(Fields.D_RELATIVE_WEIGHT)
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry.CmgTableEntryBuilder dRelativeWeight(final BigDecimal dRelativeWeight) {
      this.dRelativeWeight = dRelativeWeight;
      return this;
    }

    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public CmgTableEntry build() {
      return new CmgTableEntry(this.cmgCode, this.aAvgLengthOfStay, this.aRelativeWeight, this.bAvgLengthOfStay, this.bRelativeWeight, this.cAvgLengthOfStay, this.cRelativeWeight, this.dAvgLengthOfStay, this.dRelativeWeight);
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("all")
    @lombok.Generated
    public java.lang.String toString() {
      return "CmgTableEntry.CmgTableEntryBuilder(cmgCode=" + this.cmgCode + ", aAvgLengthOfStay=" + this.aAvgLengthOfStay + ", aRelativeWeight=" + this.aRelativeWeight + ", bAvgLengthOfStay=" + this.bAvgLengthOfStay + ", bRelativeWeight=" + this.bRelativeWeight + ", cAvgLengthOfStay=" + this.cAvgLengthOfStay + ", cRelativeWeight=" + this.cRelativeWeight + ", dAvgLengthOfStay=" + this.dAvgLengthOfStay + ", dRelativeWeight=" + this.dRelativeWeight + ")";
    }
  }

  /**
   * Corresponds to {@code CMG-NUM PIC X(4)} from the COBOL source.
   */
  @Pattern(regexp = "\\d{4}")
  private final String cmgCode;
  /**
   * Corresponds to {@code A-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @JsonProperty(Fields.A_AVG_LENGTH_OF_STAY)
  @Min(0)
  @Max(99)
  private final int aAvgLengthOfStay;
  /**
   * Corresponds to {@code A-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @JsonProperty(Fields.A_RELATIVE_WEIGHT)
  @Digits(integer = 1, fraction = 4)
  private final BigDecimal aRelativeWeight;
  /**
   * Corresponds to {@code B-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @JsonProperty(Fields.B_AVG_LENGTH_OF_STAY)
  @Min(0)
  @Max(99)
  private final int bAvgLengthOfStay;
  /**
   * Corresponds to {@code B-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @JsonProperty(Fields.B_RELATIVE_WEIGHT)
  @Digits(integer = 1, fraction = 4)
  private final BigDecimal bRelativeWeight;
  /**
   * Corresponds to {@code C-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @JsonProperty(Fields.C_AVG_LENGTH_OF_STAY)
  @Min(0)
  @Max(99)
  private final int cAvgLengthOfStay;
  /**
   * Corresponds to {@code C-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @JsonProperty(Fields.C_RELATIVE_WEIGHT)
  @Digits(integer = 1, fraction = 4)
  private final BigDecimal cRelativeWeight;
  /**
   * Corresponds to {@code D-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @JsonProperty(Fields.D_AVG_LENGTH_OF_STAY)
  @Min(0)
  @Max(99)
  private final int dAvgLengthOfStay;
  /**
   * Corresponds to {@code D-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @JsonProperty(Fields.D_RELATIVE_WEIGHT)
  @Digits(integer = 1, fraction = 4)
  private final BigDecimal dRelativeWeight;

  public CmgTableEntryBuilder copyBuilder() {
    return CmgTableEntry.builder().cmgCode(getCmgCode()).aAvgLengthOfStay(getAAvgLengthOfStay()).aRelativeWeight(getARelativeWeight()).bAvgLengthOfStay(getBAvgLengthOfStay()).bRelativeWeight(getBRelativeWeight()).cAvgLengthOfStay(getCAvgLengthOfStay()).cRelativeWeight(getCRelativeWeight()).dAvgLengthOfStay(getDAvgLengthOfStay()).dRelativeWeight(getDRelativeWeight());
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  CmgTableEntry(final String cmgCode, final int aAvgLengthOfStay, final BigDecimal aRelativeWeight, final int bAvgLengthOfStay, final BigDecimal bRelativeWeight, final int cAvgLengthOfStay, final BigDecimal cRelativeWeight, final int dAvgLengthOfStay, final BigDecimal dRelativeWeight) {
    this.cmgCode = cmgCode;
    this.aAvgLengthOfStay = aAvgLengthOfStay;
    this.aRelativeWeight = aRelativeWeight;
    this.bAvgLengthOfStay = bAvgLengthOfStay;
    this.bRelativeWeight = bRelativeWeight;
    this.cAvgLengthOfStay = cAvgLengthOfStay;
    this.cRelativeWeight = cRelativeWeight;
    this.dAvgLengthOfStay = dAvgLengthOfStay;
    this.dRelativeWeight = dRelativeWeight;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public static CmgTableEntry.CmgTableEntryBuilder builder() {
    return new CmgTableEntry.CmgTableEntryBuilder();
  }

  /**
   * Corresponds to {@code CMG-NUM PIC X(4)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getCmgCode() {
    return this.cmgCode;
  }

  /**
   * Corresponds to {@code A-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int getAAvgLengthOfStay() {
    return this.aAvgLengthOfStay;
  }

  /**
   * Corresponds to {@code A-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getARelativeWeight() {
    return this.aRelativeWeight;
  }

  /**
   * Corresponds to {@code B-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int getBAvgLengthOfStay() {
    return this.bAvgLengthOfStay;
  }

  /**
   * Corresponds to {@code B-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getBRelativeWeight() {
    return this.bRelativeWeight;
  }

  /**
   * Corresponds to {@code C-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int getCAvgLengthOfStay() {
    return this.cAvgLengthOfStay;
  }

  /**
   * Corresponds to {@code C-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCRelativeWeight() {
    return this.cRelativeWeight;
  }

  /**
   * Corresponds to {@code D-LOS-TABLE PIC 9(2)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int getDAvgLengthOfStay() {
    return this.dAvgLengthOfStay;
  }

  /**
   * Corresponds to {@code D-REL-WGT PIC 9(1)V9(4)} from the COBOL source.
   */
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getDRelativeWeight() {
    return this.dRelativeWeight;
  }


  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public static final class Fields {
    public static final java.lang.String CMG_CODE = "cmgCode";
    public static final java.lang.String A_AVG_LENGTH_OF_STAY = "aAvgLengthOfStay";
    public static final java.lang.String A_RELATIVE_WEIGHT = "aRelativeWeight";
    public static final java.lang.String B_AVG_LENGTH_OF_STAY = "bAvgLengthOfStay";
    public static final java.lang.String B_RELATIVE_WEIGHT = "bRelativeWeight";
    public static final java.lang.String C_AVG_LENGTH_OF_STAY = "cAvgLengthOfStay";
    public static final java.lang.String C_RELATIVE_WEIGHT = "cRelativeWeight";
    public static final java.lang.String D_AVG_LENGTH_OF_STAY = "dAvgLengthOfStay";
    public static final java.lang.String D_RELATIVE_WEIGHT = "dRelativeWeight";
  }
}
